clear 
Pmax=610;
Vmp=45.41;
Imp=13.43;
Voc_stc=53.6;
Isc_stc=14.03;
eta=0.236;
niVoc=-0.24/100;
niIsc=0.05/100;
niPmax=-0.29/100;
T0=25;
G0=1000;
Rs=10*10^(-3);
G=linspace(200,1000,5);
DeltaI=zeros(length(G));
DeltaV=zeros(length(G));
Isc=zeros(length(G));
Voc=zeros(length(G));

C2=(Vmp-Voc_stc)/log(1-Imp/Isc_stc);
C1=Isc_stc/(1-exp(-Voc_stc/C2));

%Isc and Voc Update due to temperature and G variation
for i=1:length(G)
    DeltaI(i)=Isc_stc*(G(i)/G0-1)+niIsc*(G(i)/G0)*(T0-T0);
    Isc(i)=Isc_stc+DeltaI(i);
    DeltaV(i)=niVoc*(T0-T0)-Rs*DeltaI(i);
    Voc(i)=Voc_stc+DeltaV(i); 
end
V=linspace(0,60,500);
PV_I=real(zeros(length(V)+1,length(G)));
for i=1:length(V)
    for j=1:(length(G)+1)
        if j==1
            PV_I(i,j)=0;
        else
        PV_I(i,j)=Isc(j-1)-C1*exp(-Voc(j-1)/C2)*(exp(V(i)/C2)-1);
        if PV_I(i,j)<0
            PV_I(i,j)=0;
        end
        end
    end
end
save('PV_I.mat','PV_I');

%Plot the I_V Charcateristic depending from Irradiance (G)

  I=Isc(1)-C1*exp(-Voc(1)/C2)*(exp(V/C2)-1);
  I(I<0)=0;
  plot(V,I,'b');
  hold on
  I=Isc(2)-C1*exp(-Voc(2)/C2)*(exp(V/C2)-1);
  I(I<0)=0;
  plot(V,I,'r');
  hold on
  I=Isc(3)-C1*exp(-Voc(3)/C2)*(exp(V/C2)-1);
  I(I<0)=0;
  plot(V,I,'g');
  hold on
  I=Isc(4)-C1*exp(-Voc(4)/C2)*(exp(V/C2)-1);
  I(I<0)=0;
  plot(V,I,'y');
  hold on
  I=Isc(5)-C1*exp(-Voc(5)/C2)*(exp(V/C2)-1);
  I(I<0)=0;
  plot(V,I);
  hold on
  xlabel('V[V]');
  ylabel('I[A]');
  title('I-V Characteristic')
  grid on

